
public class ArrayIntPQ implements IntPriorityQueue
{
    private int size;
    private int[] queue;

    public ArrayIntPQ(int maxSize)
    {
        queue = new int[maxSize];
        size = 0;
    }

    public int size()
    {
        return size;
    }
    
    public boolean isFull()
    {
        return size < queue.length;
    }
    
    /**
     * Supposes that the queue is not empty
     */
    public int removeMax()
    {
       size--;
       return queue[size];
    }
    
    public void insert(int element)
    {
        if(size == 0)
        {
            queue[0] = element;
            size++;
            return;
        }
        
        int i = 0;
        while(queue[i] <= element)
            i++;
            
        for(int j = size; j > i; j--)
            queue[j] = queue[j-1];
            
        size++;
        queue[i] = element;        
    }
}
