
public class Circle
{
    private Point center;
    public double radius;

    public Circle(Point a, double r)
    {
        center = a;
        radius = r;
    }

    public Point getCenter()
    {
        return center;
    }
    
    public double getRadius()
    {
        return radius;
    }
    
    public boolean isOnCircle(Point p)
    {
        Segment distance = new Segment(center, p);
        return radius == distance.length();
    }

    public boolean containsPoint(Point p)
    {
        Segment distance = new Segment(center, p);
        return radius >= distance.length();
    }
    
    public boolean containsSegment(Segment s)
    {
        return containsPoint(s.getP1()) && containsPoint(s.getP2());
    }
    
    public boolean instersectsSegment(Segment s)
    {
        boolean a = containsPoint(s.getP1());
        boolean b = containsPoint(s.getP2());
        return a ^ b;
        //equivalent expressions
        //return (a && !b) || (b && !a);
        //return (a || b) && !(a && b);
        //return a != b;
    }
}
